<script lang="ts">
  import { onMount } from "svelte";
  import {
    Collapse,
    Navbar,
    NavbarToggler,
    Nav,
    NavItem,
    NavLink,
    Dropdown,
    DropdownToggle,
    DropdownMenu,
    DropdownItem,
    NavbarBrand
  } from "@sveltestrap/sveltestrap";
  import { eventId, settings, keycloak, roles, team } from "@stores";
  import type { EventConfiguration } from "@models/EventConfigurations";
  import Countdown from "./Countdown.svelte";
  import { Gql } from "@db";
  import { EventCfgByIdQuery } from "@models/EventConfigurations";
  import { faFileImport, faServer, faSliders, faStar, faUserPlus } from "@fortawesome/free-solid-svg-icons";
  import Fa from "svelte-fa";

  let isOpen = false;
  let eventCfg: EventConfiguration | null = null;

  onMount(async () => {
    Gql.subscribeSimple<{ events_by_pk: EventConfiguration }>(
      `subscription ${EventCfgByIdQuery($eventId)}`,
      (data) => (eventCfg = data.events_by_pk)
    );
  });

  function handleUpdate(event) {
    isOpen = event.detail.isOpen;
  }
</script>

<Navbar expand="lg" class="custom-navbar" style="z-index: 1030">
  <NavbarBrand class="navbar-brand-with-counter text-white">
    {#if eventCfg != null}
      {#key eventCfg}
        <Countdown {eventCfg} id="nav-countdown" placement="bottom" size={18} />
      {/key}
    {/if}
    {eventCfg ? eventCfg.name : 'Hackathon'}
  </NavbarBrand>
  <NavbarToggler on:click={() => (isOpen = !isOpen)} />
  <Collapse {isOpen} navbar expand="lg" on:update={handleUpdate}>
    <Nav class="mr-auto" navbar>
      <NavItem>
        {#if $settings.flags.userDashboard}
          <NavLink class="link-underline" href="/scoring/info">Competition Info</NavLink>
        {/if}
      </NavItem>
      <NavItem>
        <NavLink class="link-underline" href="/scoreboard">Scoreboard</NavLink>
      </NavItem>
      {#if ($team || $keycloak.isStaff()) && $settings.flags.ctf}
        <NavItem>
          <NavLink class="link-underline" href="/challenges">Challenges</NavLink>
        </NavItem>
      {/if}
      {#if $team}
          <NavItem>
            <NavLink class="link-underline" href="/teams/{$team.id}">Team Dashboard</NavLink>
          </NavItem>
          {#if $settings.flags.infrastructure}
            <NavItem>
              <NavLink class="link-underline" href="/teams/{$team.id}/service-feedback">Service Details</NavLink>
            </NavItem>
          {/if}
          <NavItem>
            <NavLink class="link-underline" href="/task-board">Task Board</NavLink>
          </NavItem>
      {:else}
        {#if $settings.flags.infrastructure}
          <NavItem>
            <NavLink class="link-underline" href="/scoring/topology">Network Topology</NavLink>
          </NavItem>
        {/if}
      {/if}
      {#if $keycloak.isStaff()}
        <NavItem>
          <NavLink class="link-underline" href="/teams">Teams</NavLink>
        </NavItem>
      {/if}
    </Nav>
    <Nav navbar class="ms-auto">
      {#if $keycloak.authenticated}
        <Dropdown nav inNavbar>
          <DropdownToggle nav caret>
            {$keycloak.tokenParsed?.name || $keycloak.userEmail}
            {$team ? `- ${$team.name}` : ''}
          </DropdownToggle>
          <DropdownMenu end>
            {#if $roles.staff}
              <DropdownItem href="/staff/event-info">Event Info</DropdownItem>
              <DropdownItem href="/staff/service-period-status">Service Period Status</DropdownItem>
              <DropdownItem divider />
            {/if}
            {#if $roles.ctfAdmin}
              <DropdownItem href="/staff/ctf/dashboard">CTF Dashboard</DropdownItem>
              <DropdownItem href="/staff/ctf/challenges">Edit CTF Challenges</DropdownItem>
              <DropdownItem divider />
            {/if}
            <!-- todo change this back to attacker after 2023 finals -->
            {#if $roles.staff}
              <DropdownItem href="/staff/attacker/dashboard">Attacker Dashboard</DropdownItem>
              <DropdownItem href="/staff/team-feedback">Team Feedback</DropdownItem>
              <DropdownItem divider />
            {/if}
            {#if $roles.eventAdmin}
              <DropdownItem href="/admin/teams">
                <Fa icon={faUserPlus} />
                Edit Teams
              </DropdownItem>
              <DropdownItem href="/admin/event-configuration/tapi-import">
                <Fa icon={faFileImport} />
                Import TAPI Event
              </DropdownItem>
              <!-- <DropdownItem href="/admin/event-configuration"><Fa icon={faServer} /> Configure Event</DropdownItem>-->
              <DropdownItem href="/admin/services">
                <Fa icon={faServer} />
                Edit Checks
              </DropdownItem>
              <DropdownItem href="/admin/bonuses">
                <Fa icon={faStar} />
                Award/Dock Points
              </DropdownItem>
              <DropdownItem divider />
              <DropdownItem href="/admin/event-configuration/variables/check">
                <Fa icon={faSliders} />
                Check Variables
              </DropdownItem>
              <DropdownItem href="/admin/event-configuration/variables/event">
                <Fa icon={faSliders} />
                Event Variables
              </DropdownItem>
              <DropdownItem href="/admin/event-configuration/variables/team">
                <Fa icon={faSliders} />
                Team Variables
              </DropdownItem>
              <DropdownItem divider />
            {/if}
            {#if $settings.flags.userDashboard}
              <DropdownItem href="/scoring/info">Competition Info</DropdownItem>
            {/if}
            {#if $team}
              {#if $settings.flags.infrastructure}
                <DropdownItem href="/teams/{$team.id}/service-feedback">Service Details</DropdownItem>
              {/if}
              <DropdownItem href="/teams/{$team.id}">Team Dashboard</DropdownItem>
            {/if}
            {#if $settings.flags.infrastructure}
              <DropdownItem href="/scoring/topology">Topology</DropdownItem>
            {/if}
            {#if $settings.flags.ctf}
              <DropdownItem href="/challenges">Challenges</DropdownItem>
            {/if}
            {#if $settings.flags.inject}
              <DropdownItem href="/challenges/inject">Inject</DropdownItem>
            {/if}
            <DropdownItem divider />

            <DropdownItem class="clickable" on:click={() => $keycloak.logout()}>
              Logout
            </DropdownItem>
          </DropdownMenu>
        </Dropdown>
      {:else}
        <NavItem>
          <NavLink href="javascript:void(0)" on:click={() => $keycloak.login(window.location.href)}>
            Login
          </NavLink>
        </NavItem>
      {/if}
    </Nav>
  </Collapse>
</Navbar>
